/* */

workdir='g:\sre2k'

say "Modifiying SRE2000.CFG"
foo=mod_ini(workdir,'SREHTTP2.RXX','DMN2000.RXX',datadir)

exit

/***************/
/* modify sre2000.cfg */
mod_ini:procedure expose cy_ye normal bold reverse crlf aesc
parse arg workdir,filtername,dmnname,datadir

daname=workdir'\SRE2000.CFG'

signal on halt name foomod


foo=strip(translate(stream(daname,'c','open read')))
if abbrev(foo,'READY')=0 then do
   say reverse'ERROR:'normal' can not open initialization file: 'daname
   return 'no changes'
end 
isz=stream(daname,'c','query size')
if (isz=0 | isz='') then do
   say reverse'ERROR:'normal' empty or missing initialization file: 'daname
   return 'no changes'
end 
stuff=charin(daname,1,isz)
foo=stream(daname,'c','close')


say isz " bytes in the "daname" initialization file."

mm=0
do until stuff=''
   parse var stuff aline '0d0a'x stuff
   aline=strip(aline)
   if abbrev(translate(aline),';LAST-MODIFIED:')=1 then do
     iterate
   end
   mm=mm+1
   stuffs.mm=aline
   if aline='' | abbrev(aline,';')=1 then do
     stuffs.mm.!type='C'
   end
   else do
        parse var aline vname '=' vval
        vvname=strip(vvname)
        stuffs.mm.!VAR=strip(vname)
        stuffs.mm.!VAL=strip(vval)
        currentvars=currentvars' '||translate(strip(vname))
   end 
end 
stuffs.0=mm

jines.0=0
/* pre processing is done. Now make changes */
do forever
  if jj>stuffs.0 then leave
  aline=stuffs.jj
  if stuffs.jj.!type='C'  then do
      ith=jines.0+1
      jines.ith=aline
      jines.0=ith 
      jj=jj+1
      iterate
  end 

  vname0=translate(stuffs.jj.!VAR)

 select
   when vname0='FILTER' then stuffs.jj.!VAL=filtername
   when vname0='DAEMON_MANAGER' then stuffs.jj.!VAL=dmnname
   when vname0='DATADIR' then stuffs.jj.!VAL=datadir
   otherwise nop
 end 
end

lastmodline=';last-modified: '||date('n')||' '||time('n')
ith=jines.0+1
jines.ith=lastmodline
jines.0=ith


if dosisdir(workdir'old')=1 then
  dd='old\'||daname
else
  dd=daname

ip=pos('.',dd)
if ip=0 then do
   bakfile=dd||'.V??'
end
else do
   bakfile=left(dd,ip)||'V??'
end
bakfile=dostempname(bakfile)
say daname ' is being renamed as '  bakfile
foo=dosrename(daname,bakfile)
if foo=0 then   say " Warning: ERROR renaming! "

outfile=daname
do mm=1 to jines.0
   call lineout outfile,jines.mm
end 
call lineout outfile

return nchanges" were made "


